=== modified file 'README'
--- README	2017-08-17 11:10:50 +0000
+++ README	2017-08-21 08:35:44 +0000
@@ -41,7 +41,7 @@
 Initialising Database: PostreSQL -----------------------------------------------
 
   In postgres you need to start psql from the terminal:
-$ psql -U <username> -a -f ./src/main/resources/create_db.sql
+$ psql -h localhost -U postgres -a -f ./src/main/resources/create_db.sql
   If the your database username is "postgres", you should use that. press enter
 and enter the password fot the database user.
 
@@ -62,7 +62,7 @@
 
   Now that you have created the database you need to initialise the tables, to
 do this you need to run the following:
-$ psql -U <username> -d mag_studentportal \
+$ psql -h localhost -U postgres -d mag_studentportal \
   -a -f ./src/main/resources/create_tables.sql
   That should run without any errors.
 

=== modified file 'pom.xml'
--- pom.xml	2017-08-17 11:10:50 +0000
+++ pom.xml	2017-08-28 13:28:34 +0000
@@ -58,6 +58,28 @@
       <version>42.1.4</version>
     </dependency>
 
+    <!-- https://mvnrepository.com/artifact/junit/junit -->
+    <dependency>
+      <groupId>junit</groupId>
+      <artifactId>junit</artifactId>
+      <version>4.12</version>
+    </dependency>
+    <!-- https://mvnrepository.com/artifact/javax.faces/javax.faces-api -->
+    <dependency>
+      <groupId>javax.faces</groupId>
+      <artifactId>javax.faces-api</artifactId>
+      <version>2.3</version>
+      <scope>provided</scope>
+    </dependency>
+    <!-- https://mvnrepository.com/artifact/org.bouncycastle/bcprov-jdk15on -->
+    <dependency>
+      <groupId>org.bouncycastle</groupId>
+      <artifactId>bcprov-jdk15on</artifactId>
+      <version>1.58</version>
+    </dependency>
+
   </dependencies>
 
+
+
 </project>

=== added directory 'src/main/java/beans'
=== added file 'src/main/java/beans/ConfigBean.java'
--- src/main/java/beans/ConfigBean.java	1970-01-01 00:00:00 +0000
+++ src/main/java/beans/ConfigBean.java	2017-08-23 09:48:39 +0000
@@ -0,0 +1,44 @@
+import java.io.Serializable;
+
+import javax.faces.bean.*;
+
+
+@SuppressWarnings({ "serial", "deprecation" })
+@ManagedBean(name = "configBean", eager = true)
+@ApplicationScoped
+public class
+ConfigBean implements Serializable {
+  /****************************************************************************/
+  private static String
+  PAGE_TITLE = "MAG Student Portal";
+  
+  private static String
+  PAGE_SUB_TITLE = "My school";
+  
+  private static String
+  PAGE_HEADER_TITLE_URL = "./index.xhtml";
+  
+  private static String
+  PAGE_HEADER_SUB_TITLE_URL = "./index.xhtml";
+  
+  /****************************************************************************/
+  public String
+  getPageTitle () {
+    return PAGE_TITLE;
+  }
+  
+  public String
+  getSubTitle () {
+    return PAGE_SUB_TITLE;
+  }
+  
+  public String
+  getHeaderTitleUrl () {
+    return PAGE_HEADER_TITLE_URL;
+  }
+  
+  public String
+  getHeaderSubTitleUrl () {
+	  return PAGE_HEADER_SUB_TITLE_URL;
+  }
+}

=== added file 'src/main/java/beans/LoginBean.java'
--- src/main/java/beans/LoginBean.java	1970-01-01 00:00:00 +0000
+++ src/main/java/beans/LoginBean.java	2017-08-28 13:28:34 +0000
@@ -0,0 +1,30 @@
+package beans;
+
+import javax.faces.bean.*;
+import common;
+
+
+@ManagedBean
+@SessionScoped
+public class
+LoginBean {
+  private boolean
+  is_logeed_in = false;
+
+  private UserTypeEnum
+  user_type = UserTypeEnum.NONE;
+  
+
+
+  /****************************************************************************/
+
+  public void
+  studentLognin (String user_name, String password) {
+    
+  }
+
+  public void
+  staffLognin (String user_name, String password) {
+    
+  }
+}

=== added directory 'src/main/java/common'
=== added file 'src/main/java/common/Config.java'
--- src/main/java/common/Config.java	1970-01-01 00:00:00 +0000
+++ src/main/java/common/Config.java	2017-08-18 12:05:06 +0000
@@ -0,0 +1,6 @@
+package common;
+
+public class Config {
+  public static
+  String PW_SALT = "CHANGE_ME!";
+}

=== added file 'src/main/java/common/UserTypeEnum.java'
--- src/main/java/common/UserTypeEnum.java	1970-01-01 00:00:00 +0000
+++ src/main/java/common/UserTypeEnum.java	2017-08-28 13:28:34 +0000
@@ -0,0 +1,7 @@
+package common;
+
+enum {
+  NONE = 0,
+  STUDENT = 1,
+  STAFF = 2;
+}

=== added file 'src/main/java/common/Utils.java'
--- src/main/java/common/Utils.java	1970-01-01 00:00:00 +0000
+++ src/main/java/common/Utils.java	2017-08-28 13:28:34 +0000
@@ -0,0 +1,45 @@
+package common;
+
+import org.bouncycastle.jcajce.provider.digest.SHA3.*;
+import org.bouncycastle.util.encoders.*;
+
+
+public class
+Utils {
+  private Utils () {};
+  
+  /**
+   * A hash function that salts the password
+   * in a way that is pseudo dynamic.
+   * 
+   * @param t the text to salt
+   * @param s the salt
+   * @return
+   */
+  static public String
+  real_hash_func (String t, String s) {
+    int a = t.getBytes()[0];
+    int b = t.getBytes()[a%t.length()];
+    
+    StringBuilder sb = new StringBuilder ();
+    sb.append (t).insert (b, s);
+    
+    DigestSHA3 md = DigestSHA3 (2048);
+    md.update (sb.toString().getBytes("UTF-8"));
+
+    return Hex.toHexString (md.digits ());
+  }
+  
+  /**
+   * Hash a text with a salt.
+   * 
+   * @param t
+   * @return
+   */
+  static public String
+  hash_func (String t) {
+    return real_hash_func(t, common.Config.PW_SALT);
+  }
+  
+  
+}

=== renamed directory 'src/main/java/DB' => 'src/main/java/db'
=== modified file 'src/main/java/db/Course.java'
--- src/main/java/DB/Course.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/Course.java	2017-08-17 13:09:18 +0000
@@ -4,79 +4,74 @@
 import javax.persistence.*;
 import java.util.List;
 
-
 /**
  * The persistent class for the course database table.
  * 
  */
 @Entity
-@Table(name="course")
-@NamedQuery(name="Course.findAll", query="SELECT c FROM Course c")
+@Table(name = "course")
+@NamedQuery(name = "Course.findAll", query = "SELECT c FROM Course c")
 public class Course implements Serializable {
-	private static final long serialVersionUID = 1L;
-	private Integer id;
-	private String description;
-	private String name;
-	private List<Lecture> lectures;
-
-	public Course() {
-	}
-
-
-	@Id
-	@GeneratedValue(strategy=GenerationType.AUTO)
-	@Column(unique=true, nullable=false)
-	public Integer getId() {
-		return this.id;
-	}
-
-	public void setId(Integer id) {
-		this.id = id;
-	}
-
-
-	@Column(length=2147483647)
-	public String getDescription() {
-		return this.description;
-	}
-
-	public void setDescription(String description) {
-		this.description = description;
-	}
-
-
-	@Column(length=30)
-	public String getName() {
-		return this.name;
-	}
-
-	public void setName(String name) {
-		this.name = name;
-	}
-
-
-	//bi-directional many-to-one association to Lecture
-	@OneToMany(mappedBy="courseBean")
-	public List<Lecture> getLectures() {
-		return this.lectures;
-	}
-
-	public void setLectures(List<Lecture> lectures) {
-		this.lectures = lectures;
-	}
-
-	public Lecture addLecture(Lecture lecture) {
-		getLectures().add(lecture);
-		lecture.setCourseBean(this);
-
-		return lecture;
-	}
-
-	public Lecture removeLecture(Lecture lecture) {
-		getLectures().remove(lecture);
-		lecture.setCourseBean(null);
-
-		return lecture;
-	}
+  private static final long serialVersionUID = 1L;
+  private Integer id;
+  private String description;
+  private String name;
+  private List<Lecture> lectures;
+
+  public Course() {
+  }
+
+  @Id
+  @GeneratedValue(strategy = GenerationType.AUTO)
+  @Column(unique = true, nullable = false)
+  public Integer getId() {
+    return this.id;
+  }
+
+  public void setId(Integer id) {
+    this.id = id;
+  }
+
+  @Column(length = 2147483647)
+  public String getDescription() {
+    return this.description;
+  }
+
+  public void setDescription(String description) {
+    this.description = description;
+  }
+
+  @Column(length = 30)
+  public String getName() {
+    return this.name;
+  }
+
+  public void setName(String name) {
+    this.name = name;
+  }
+
+  // bi-directional many-to-one association to Lecture
+  @OneToMany(mappedBy = "courseBean")
+  public List<Lecture> getLectures() {
+    return this.lectures;
+  }
+
+  public void setLectures(List<Lecture> lectures) {
+    this.lectures = lectures;
+  }
+
+  public Lecture addLecture(Lecture lecture) {
+    getLectures().add(lecture);
+    lecture.setCourseBean(this);
+
+    return lecture;
+  }
+
+  public Lecture removeLecture(Lecture lecture) {
+    getLectures().remove(lecture);
+    lecture.setCourseBean(null);
+
+    return lecture;
+  }
 
 }
\ No newline at end of file

=== modified file 'src/main/java/db/Lecture.java'
--- src/main/java/DB/Lecture.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/Lecture.java	2017-08-18 12:02:27 +0000
@@ -4,68 +4,64 @@
 import javax.persistence.*;
 import java.util.List;
 
-
 /**
  * The persistent class for the lecture database table.
  * 
  */
 @Entity
-@Table(name="lecture")
-@NamedQuery(name="Lecture.findAll", query="SELECT l FROM Lecture l")
+@Table(name = "lecture")
+@NamedQuery(name = "Lecture.findAll", query = "SELECT l FROM Lecture l")
 public class Lecture implements Serializable {
-	private static final long serialVersionUID = 1L;
-	private LecturePK id;
-	private Course courseBean;
-	private List<StudentAttendance> studentAttendances;
-
-	public Lecture() {
-	}
-
-
-	@EmbeddedId
-	public LecturePK getId() {
-		return this.id;
-	}
-
-	public void setId(LecturePK id) {
-		this.id = id;
-	}
-
-
-	//bi-directional many-to-one association to Course
-	@ManyToOne
-	@JoinColumn(name="course", nullable=false, insertable=false, updatable=false)
-	public Course getCourseBean() {
-		return this.courseBean;
-	}
-
-	public void setCourseBean(Course courseBean) {
-		this.courseBean = courseBean;
-	}
-
-
-	//bi-directional many-to-one association to StudentAttendance
-	@OneToMany(mappedBy="lecture")
-	public List<StudentAttendance> getStudentAttendances() {
-		return this.studentAttendances;
-	}
-
-	public void setStudentAttendances(List<StudentAttendance> studentAttendances) {
-		this.studentAttendances = studentAttendances;
-	}
-
-	public StudentAttendance addStudentAttendance(StudentAttendance studentAttendance) {
-		getStudentAttendances().add(studentAttendance);
-		studentAttendance.setLecture(this);
-
-		return studentAttendance;
-	}
-
-	public StudentAttendance removeStudentAttendance(StudentAttendance studentAttendance) {
-		getStudentAttendances().remove(studentAttendance);
-		studentAttendance.setLecture(null);
-
-		return studentAttendance;
-	}
+  private static final long serialVersionUID = 1L;
+  private LecturePK id;
+  private Course courseBean;
+  private List<StudentAttendance> studentAttendances;
+
+  public Lecture() {
+  }
+
+  @EmbeddedId
+  public LecturePK getId() {
+    return this.id;
+  }
+
+  public void setId(LecturePK id) {
+    this.id = id;
+  }
+
+  // bi-directional many-to-one association to Course
+  @ManyToOne
+  @JoinColumn(name = "course", nullable = false, insertable = false, updatable = false)
+  public Course getCourseBean() {
+    return this.courseBean;
+  }
+
+  public void setCourseBean(Course courseBean) {
+    this.courseBean = courseBean;
+  }
+
+  // bi-directional many-to-one association to StudentAttendance
+  @OneToMany(mappedBy = "lecture")
+  public List<StudentAttendance> getStudentAttendances() {
+    return this.studentAttendances;
+  }
+
+  public void setStudentAttendances(List<StudentAttendance> studentAttendances) {
+    this.studentAttendances = studentAttendances;
+  }
+
+  public StudentAttendance addStudentAttendance(StudentAttendance studentAttendance) {
+    getStudentAttendances().add(studentAttendance);
+    studentAttendance.setLecture(this);
+
+    return studentAttendance;
+  }
+
+  public StudentAttendance removeStudentAttendance(StudentAttendance studentAttendance) {
+    getStudentAttendances().remove(studentAttendance);
+    studentAttendance.setLecture(null);
+
+    return studentAttendance;
+  }
 
 }
\ No newline at end of file

=== modified file 'src/main/java/db/LecturePK.java'
--- src/main/java/DB/LecturePK.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/LecturePK.java	2017-08-18 12:02:27 +0000
@@ -9,62 +9,63 @@
  */
 @Embeddable
 public class LecturePK implements Serializable {
-	//default serial version id, required for serializable classes.
-	private static final long serialVersionUID = 1L;
-	private Long course;
-	private java.util.Date startTime;
-	private java.util.Date endTime;
-
-	public LecturePK() {
-	}
-
-	@Column(insertable=false, updatable=false, unique=true, nullable=false)
-	public Long getCourse() {
-		return this.course;
-	}
-	public void setCourse(Long course) {
-		this.course = course;
-	}
-
-	@Temporal(TemporalType.TIMESTAMP)
-	@Column(name="start_time", unique=true, nullable=false)
-	public java.util.Date getStartTime() {
-		return this.startTime;
-	}
-	public void setStartTime(java.util.Date startTime) {
-		this.startTime = startTime;
-	}
-
-	@Temporal(TemporalType.TIMESTAMP)
-	@Column(name="end_time", unique=true, nullable=false)
-	public java.util.Date getEndTime() {
-		return this.endTime;
-	}
-	public void setEndTime(java.util.Date endTime) {
-		this.endTime = endTime;
-	}
-
-	public boolean equals(Object other) {
-		if (this == other) {
-			return true;
-		}
-		if (!(other instanceof LecturePK)) {
-			return false;
-		}
-		LecturePK castOther = (LecturePK)other;
-		return 
-			this.course.equals(castOther.course)
-			&& this.startTime.equals(castOther.startTime)
-			&& this.endTime.equals(castOther.endTime);
-	}
-
-	public int hashCode() {
-		final int prime = 31;
-		int hash = 17;
-		hash = hash * prime + this.course.hashCode();
-		hash = hash * prime + this.startTime.hashCode();
-		hash = hash * prime + this.endTime.hashCode();
-		
-		return hash;
-	}
+  // default serial version id, required for serializable classes.
+  private static final long serialVersionUID = 1L;
+  private Long course;
+  private java.util.Date startTime;
+  private java.util.Date endTime;
+
+  public LecturePK() {
+  }
+
+  @Column(insertable = false, updatable = false, unique = true, nullable = false)
+  public Long getCourse() {
+    return this.course;
+  }
+
+  public void setCourse(Long course) {
+    this.course = course;
+  }
+
+  @Temporal(TemporalType.TIMESTAMP)
+  @Column(name = "start_time", unique = true, nullable = false)
+  public java.util.Date getStartTime() {
+    return this.startTime;
+  }
+
+  public void setStartTime(java.util.Date startTime) {
+    this.startTime = startTime;
+  }
+
+  @Temporal(TemporalType.TIMESTAMP)
+  @Column(name = "end_time", unique = true, nullable = false)
+  public java.util.Date getEndTime() {
+    return this.endTime;
+  }
+
+  public void setEndTime(java.util.Date endTime) {
+    this.endTime = endTime;
+  }
+
+  public boolean equals(Object other) {
+    if (this == other) {
+      return true;
+    }
+    if (!(other instanceof LecturePK)) {
+      return false;
+    }
+    LecturePK castOther = (LecturePK) other;
+    return this.course.equals(castOther.course) && this.startTime.equals(castOther.startTime)
+        && this.endTime.equals(castOther.endTime);
+  }
+
+  public int hashCode() {
+    final int prime = 31;
+    int hash = 17;
+    hash = hash * prime + this.course.hashCode();
+    hash = hash * prime + this.startTime.hashCode();
+    hash = hash * prime + this.endTime.hashCode();
+
+    return hash;
+  }
 }
\ No newline at end of file

=== modified file 'src/main/java/db/Staff.java'
--- src/main/java/DB/Staff.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/Staff.java	2017-08-18 12:02:27 +0000
@@ -3,88 +3,81 @@
 import java.io.Serializable;
 import javax.persistence.*;
 
-
 /**
  * The persistent class for the staff database table.
  * 
  */
 @Entity
-@Table(name="staff")
-@NamedQuery(name="Staff.findAll", query="SELECT s FROM Staff s")
+@Table(name = "staff")
+@NamedQuery(name = "Staff.findAll", query = "SELECT s FROM Staff s")
 public class Staff implements Serializable {
-	private static final long serialVersionUID = 1L;
-	private Integer id;
-	private String nameFirst;
-	private String nameLast;
-	private String pwd;
-	private String userName;
-	private StaffType staffTypeBean;
-
-	public Staff() {
-	}
-
-
-	@Id
-	@GeneratedValue(strategy=GenerationType.AUTO)
-	@Column(unique=true, nullable=false)
-	public Integer getId() {
-		return this.id;
-	}
-
-	public void setId(Integer id) {
-		this.id = id;
-	}
-
-
-	@Column(name="name_first", nullable=false, length=32)
-	public String getNameFirst() {
-		return this.nameFirst;
-	}
-
-	public void setNameFirst(String nameFirst) {
-		this.nameFirst = nameFirst;
-	}
-
-
-	@Column(name="name_last", nullable=false, length=32)
-	public String getNameLast() {
-		return this.nameLast;
-	}
-
-	public void setNameLast(String nameLast) {
-		this.nameLast = nameLast;
-	}
-
-
-	@Column(nullable=false, length=256)
-	public String getPwd() {
-		return this.pwd;
-	}
-
-	public void setPwd(String pwd) {
-		this.pwd = pwd;
-	}
-
-
-	@Column(name="user_name", nullable=false, length=32)
-	public String getUserName() {
-		return this.userName;
-	}
-
-	public void setUserName(String userName) {
-		this.userName = userName;
-	}
-
-
-	//bi-directional many-to-one association to StaffType
-	@ManyToOne
-	@JoinColumn(name="staff_type")
-	public StaffType getStaffTypeBean() {
-		return this.staffTypeBean;
-	}
-
-	public void setStaffTypeBean(StaffType staffTypeBean) {
-		this.staffTypeBean = staffTypeBean;
-	}
+  private static final long serialVersionUID = 1L;
+  private Integer id;
+  private String nameFirst;
+  private String nameLast;
+  private String pwd;
+  private String userName;
+  private StaffType staffTypeBean;
+
+  public Staff() {
+  }
+
+  @Id
+  @GeneratedValue(strategy = GenerationType.AUTO)
+  @Column(unique = true, nullable = false)
+  public Integer getId() {
+    return this.id;
+  }
+
+  public void setId(Integer id) {
+    this.id = id;
+  }
+
+  @Column(name = "name_first", nullable = false, length = 32)
+  public String getNameFirst() {
+    return this.nameFirst;
+  }
+
+  public void setNameFirst(String nameFirst) {
+    this.nameFirst = nameFirst;
+  }
+
+  @Column(name = "name_last", nullable = false, length = 32)
+  public String getNameLast() {
+    return this.nameLast;
+  }
+
+  public void setNameLast(String nameLast) {
+    this.nameLast = nameLast;
+  }
+
+  @Column(nullable = false, length = 256)
+  public String getPwd() {
+    return this.pwd;
+  }
+
+  public void setPwd(String pwd) {
+    this.pwd = pwd;
+  }
+
+  @Column(name = "user_name", nullable = false, length = 32)
+  public String getUserName() {
+    return this.userName;
+  }
+
+  public void setUserName(String userName) {
+    this.userName = userName;
+  }
+
+  // bi-directional many-to-one association to StaffType
+  @ManyToOne
+  @JoinColumn(name = "staff_type")
+  public StaffType getStaffTypeBean() {
+    return this.staffTypeBean;
+  }
+
+  public void setStaffTypeBean(StaffType staffTypeBean) {
+    this.staffTypeBean = staffTypeBean;
+  }
 
 }
\ No newline at end of file

=== modified file 'src/main/java/db/StaffType.java'
--- src/main/java/DB/StaffType.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/StaffType.java	2017-08-18 12:02:27 +0000
@@ -4,68 +4,64 @@
 import javax.persistence.*;
 import java.util.List;
 
-
 /**
  * The persistent class for the staff_type database table.
  * 
  */
 @Entity
-@Table(name="staff_type")
-@NamedQuery(name="StaffType.findAll", query="SELECT s FROM StaffType s")
+@Table(name = "staff_type")
+@NamedQuery(name = "StaffType.findAll", query = "SELECT s FROM StaffType s")
 public class StaffType implements Serializable {
-	private static final long serialVersionUID = 1L;
-	private Integer id;
-	private String name;
-	private List<Staff> staffs;
-
-	public StaffType() {
-	}
-
-
-	@Id
-	@GeneratedValue(strategy=GenerationType.AUTO)
-	@Column(unique=true, nullable=false)
-	public Integer getId() {
-		return this.id;
-	}
-
-	public void setId(Integer id) {
-		this.id = id;
-	}
-
-
-	@Column(length=32)
-	public String getName() {
-		return this.name;
-	}
-
-	public void setName(String name) {
-		this.name = name;
-	}
-
-
-	//bi-directional many-to-one association to Staff
-	@OneToMany(mappedBy="staffTypeBean")
-	public List<Staff> getStaffs() {
-		return this.staffs;
-	}
-
-	public void setStaffs(List<Staff> staffs) {
-		this.staffs = staffs;
-	}
-
-	public Staff addStaff(Staff staff) {
-		getStaffs().add(staff);
-		staff.setStaffTypeBean(this);
-
-		return staff;
-	}
-
-	public Staff removeStaff(Staff staff) {
-		getStaffs().remove(staff);
-		staff.setStaffTypeBean(null);
-
-		return staff;
-	}
+  private static final long serialVersionUID = 1L;
+  private Integer id;
+  private String name;
+  private List<Staff> staffs;
+
+  public StaffType() {
+  }
+
+  @Id
+  @GeneratedValue(strategy = GenerationType.AUTO)
+  @Column(unique = true, nullable = false)
+  public Integer getId() {
+    return this.id;
+  }
+
+  public void setId(Integer id) {
+    this.id = id;
+  }
+
+  @Column(length = 32)
+  public String getName() {
+    return this.name;
+  }
+
+  public void setName(String name) {
+    this.name = name;
+  }
+
+  // bi-directional many-to-one association to Staff
+  @OneToMany(mappedBy = "staffTypeBean")
+  public List<Staff> getStaffs() {
+    return this.staffs;
+  }
+
+  public void setStaffs(List<Staff> staffs) {
+    this.staffs = staffs;
+  }
+
+  public Staff addStaff(Staff staff) {
+    getStaffs().add(staff);
+    staff.setStaffTypeBean(this);
+
+    return staff;
+  }
+
+  public Staff removeStaff(Staff staff) {
+    getStaffs().remove(staff);
+    staff.setStaffTypeBean(null);
+
+    return staff;
+  }
 
 }
\ No newline at end of file

=== modified file 'src/main/java/db/Student.java'
--- src/main/java/DB/Student.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/Student.java	2017-08-18 12:02:27 +0000
@@ -4,112 +4,104 @@
 import javax.persistence.*;
 import java.util.List;
 
-
 /**
  * The persistent class for the student database table.
  * 
  */
 @Entity
-@Table(name="student")
-@NamedQuery(name="Student.findAll", query="SELECT s FROM Student s")
+@Table(name = "student")
+@NamedQuery(name = "Student.findAll", query = "SELECT s FROM Student s")
 public class Student implements Serializable {
-	private static final long serialVersionUID = 1L;
-	private Integer id;
-	private String class_;
-	private String nameFirst;
-	private String nameLast;
-	private String pwd;
-	private String userName;
-	private List<StudentAttendance> studentAttendances;
-
-	public Student() {
-	}
-
-
-	@Id
-	@GeneratedValue(strategy=GenerationType.AUTO)
-	@Column(unique=true, nullable=false)
-	public Integer getId() {
-		return this.id;
-	}
-
-	public void setId(Integer id) {
-		this.id = id;
-	}
-
-
-	@Column(name="class", length=32)
-	public String getClass_() {
-		return this.class_;
-	}
-
-	public void setClass_(String class_) {
-		this.class_ = class_;
-	}
-
-
-	@Column(name="name_first", nullable=false, length=32)
-	public String getNameFirst() {
-		return this.nameFirst;
-	}
-
-	public void setNameFirst(String nameFirst) {
-		this.nameFirst = nameFirst;
-	}
-
-
-	@Column(name="name_last", nullable=false, length=32)
-	public String getNameLast() {
-		return this.nameLast;
-	}
-
-	public void setNameLast(String nameLast) {
-		this.nameLast = nameLast;
-	}
-
-
-	@Column(nullable=false, length=256)
-	public String getPwd() {
-		return this.pwd;
-	}
-
-	public void setPwd(String pwd) {
-		this.pwd = pwd;
-	}
-
-
-	@Column(name="user_name", nullable=false, length=32)
-	public String getUserName() {
-		return this.userName;
-	}
-
-	public void setUserName(String userName) {
-		this.userName = userName;
-	}
-
-
-	//bi-directional many-to-one association to StudentAttendance
-	@OneToMany(mappedBy="studentBean")
-	public List<StudentAttendance> getStudentAttendances() {
-		return this.studentAttendances;
-	}
-
-	public void setStudentAttendances(List<StudentAttendance> studentAttendances) {
-		this.studentAttendances = studentAttendances;
-	}
-
-	public StudentAttendance addStudentAttendance(StudentAttendance studentAttendance) {
-		getStudentAttendances().add(studentAttendance);
-		studentAttendance.setStudentBean(this);
-
-		return studentAttendance;
-	}
-
-	public StudentAttendance removeStudentAttendance(StudentAttendance studentAttendance) {
-		getStudentAttendances().remove(studentAttendance);
-		studentAttendance.setStudentBean(null);
-
-		return studentAttendance;
-	}
+  private static final long serialVersionUID = 1L;
+  private Integer id;
+  private String class_;
+  private String nameFirst;
+  private String nameLast;
+  private String pwd;
+  private String userName;
+  private List<StudentAttendance> studentAttendances;
+
+  public Student() {
+  }
+
+  @Id
+  @GeneratedValue(strategy = GenerationType.AUTO)
+  @Column(unique = true, nullable = false)
+  public Integer getId() {
+    return this.id;
+  }
+
+  public void setId(Integer id) {
+    this.id = id;
+  }
+
+  @Column(name = "class", length = 32)
+  public String getClass_() {
+    return this.class_;
+  }
+
+  public void setClass_(String class_) {
+    this.class_ = class_;
+  }
+
+  @Column(name = "name_first", nullable = false, length = 32)
+  public String getNameFirst() {
+    return this.nameFirst;
+  }
+
+  public void setNameFirst(String nameFirst) {
+    this.nameFirst = nameFirst;
+  }
+
+  @Column(name = "name_last", nullable = false, length = 32)
+  public String getNameLast() {
+    return this.nameLast;
+  }
+
+  public void setNameLast(String nameLast) {
+    this.nameLast = nameLast;
+  }
+
+  @Column(nullable = false, length = 256)
+  public String getPwd() {
+    return this.pwd;
+  }
+
+  public void setPwd(String pwd) {
+    this.pwd = pwd;
+  }
+
+  @Column(name = "user_name", nullable = false, length = 32)
+  public String getUserName() {
+    return this.userName;
+  }
+
+  public void setUserName(String userName) {
+    this.userName = userName;
+  }
+
+  // bi-directional many-to-one association to StudentAttendance
+  @OneToMany(mappedBy = "studentBean")
+  public List<StudentAttendance> getStudentAttendances() {
+    return this.studentAttendances;
+  }
+
+  public void setStudentAttendances(List<StudentAttendance> studentAttendances) {
+    this.studentAttendances = studentAttendances;
+  }
+
+  public StudentAttendance addStudentAttendance(StudentAttendance studentAttendance) {
+    getStudentAttendances().add(studentAttendance);
+    studentAttendance.setStudentBean(this);
+
+    return studentAttendance;
+  }
+
+  public StudentAttendance removeStudentAttendance(StudentAttendance studentAttendance) {
+    getStudentAttendances().remove(studentAttendance);
+    studentAttendance.setStudentBean(null);
+
+    return studentAttendance;
+  }
 
 }
\ No newline at end of file

=== modified file 'src/main/java/db/StudentAttendance.java'
--- src/main/java/DB/StudentAttendance.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/StudentAttendance.java	2017-08-18 12:02:27 +0000
@@ -3,70 +3,64 @@
 import java.io.Serializable;
 import javax.persistence.*;
 
-
 /**
  * The persistent class for the student_attendance database table.
  * 
  */
 @Entity
-@Table(name="student_attendance")
-@NamedQuery(name="StudentAttendance.findAll", query="SELECT s FROM StudentAttendance s")
+@Table(name = "student_attendance")
+@NamedQuery(name = "StudentAttendance.findAll", query = "SELECT s FROM StudentAttendance s")
 public class StudentAttendance implements Serializable {
-	private static final long serialVersionUID = 1L;
-	private StudentAttendancePK id;
-	private Integer lateTime;
-	private Lecture lecture;
-	private Student studentBean;
-
-	public StudentAttendance() {
-	}
-
-
-	@EmbeddedId
-	public StudentAttendancePK getId() {
-		return this.id;
-	}
-
-	public void setId(StudentAttendancePK id) {
-		this.id = id;
-	}
-
-
-	@Column(name="late_time")
-	public Integer getLateTime() {
-		return this.lateTime;
-	}
-
-	public void setLateTime(Integer lateTime) {
-		this.lateTime = lateTime;
-	}
-
-
-	//bi-directional many-to-one association to Lecture
-	@ManyToOne
-	@JoinColumns({
-		@JoinColumn(name="lecture_course", referencedColumnName="course", nullable=false, insertable=false, updatable=false),
-		@JoinColumn(name="lecture_end_time", referencedColumnName="end_time", nullable=false, insertable=false, updatable=false),
-		@JoinColumn(name="lecture_start_time", referencedColumnName="start_time", nullable=false, insertable=false, updatable=false)
-		})
-	public Lecture getLecture() {
-		return this.lecture;
-	}
-
-	public void setLecture(Lecture lecture) {
-		this.lecture = lecture;
-	}
-
-
-	//bi-directional many-to-one association to Student
-	@ManyToOne
-	@JoinColumn(name="student", nullable=false, insertable=false, updatable=false)
-	public Student getStudentBean() {
-		return this.studentBean;
-	}
-
-	public void setStudentBean(Student studentBean) {
-		this.studentBean = studentBean;
-	}
+  private static final long serialVersionUID = 1L;
+  private StudentAttendancePK id;
+  private Integer lateTime;
+  private Lecture lecture;
+  private Student studentBean;
+
+  public StudentAttendance() {
+  }
+
+  @EmbeddedId
+  public StudentAttendancePK getId() {
+    return this.id;
+  }
+
+  public void setId(StudentAttendancePK id) {
+    this.id = id;
+  }
+
+  @Column(name = "late_time")
+  public Integer getLateTime() {
+    return this.lateTime;
+  }
+
+  public void setLateTime(Integer lateTime) {
+    this.lateTime = lateTime;
+  }
+
+  // bi-directional many-to-one association to Lecture
+  @ManyToOne
+  @JoinColumns({
+      @JoinColumn(name = "lecture_course", referencedColumnName = "course", nullable = false, insertable = false, updatable = false),
+      @JoinColumn(name = "lecture_end_time", referencedColumnName = "end_time", nullable = false, insertable = false, updatable = false),
+      @JoinColumn(name = "lecture_start_time", referencedColumnName = "start_time", nullable = false, insertable = false, updatable = false) })
+  public Lecture getLecture() {
+    return this.lecture;
+  }
+
+  public void setLecture(Lecture lecture) {
+    this.lecture = lecture;
+  }
+
+  // bi-directional many-to-one association to Student
+  @ManyToOne
+  @JoinColumn(name = "student", nullable = false, insertable = false, updatable = false)
+  public Student getStudentBean() {
+    return this.studentBean;
+  }
+
+  public void setStudentBean(Student studentBean) {
+    this.studentBean = studentBean;
+  }
 
 }
\ No newline at end of file

=== modified file 'src/main/java/db/StudentAttendancePK.java'
--- src/main/java/DB/StudentAttendancePK.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/StudentAttendancePK.java	2017-08-18 12:02:27 +0000
@@ -9,73 +9,75 @@
  */
 @Embeddable
 public class StudentAttendancePK implements Serializable {
-	//default serial version id, required for serializable classes.
-	private static final long serialVersionUID = 1L;
-	private Long lectureCourse;
-	private java.util.Date lectureStartTime;
-	private java.util.Date lectureEndTime;
-	private Long student;
-
-	public StudentAttendancePK() {
-	}
-
-	@Column(name="lecture_course", insertable=false, updatable=false, unique=true, nullable=false)
-	public Long getLectureCourse() {
-		return this.lectureCourse;
-	}
-	public void setLectureCourse(Long lectureCourse) {
-		this.lectureCourse = lectureCourse;
-	}
-
-	@Temporal(TemporalType.TIMESTAMP)
-	@Column(name="lecture_start_time", insertable=false, updatable=false, unique=true, nullable=false)
-	public java.util.Date getLectureStartTime() {
-		return this.lectureStartTime;
-	}
-	public void setLectureStartTime(java.util.Date lectureStartTime) {
-		this.lectureStartTime = lectureStartTime;
-	}
-
-	@Temporal(TemporalType.TIMESTAMP)
-	@Column(name="lecture_end_time", insertable=false, updatable=false, unique=true, nullable=false)
-	public java.util.Date getLectureEndTime() {
-		return this.lectureEndTime;
-	}
-	public void setLectureEndTime(java.util.Date lectureEndTime) {
-		this.lectureEndTime = lectureEndTime;
-	}
-
-	@Column(insertable=false, updatable=false, unique=true, nullable=false)
-	public Long getStudent() {
-		return this.student;
-	}
-	public void setStudent(Long student) {
-		this.student = student;
-	}
-
-	public boolean equals(Object other) {
-		if (this == other) {
-			return true;
-		}
-		if (!(other instanceof StudentAttendancePK)) {
-			return false;
-		}
-		StudentAttendancePK castOther = (StudentAttendancePK)other;
-		return 
-			this.lectureCourse.equals(castOther.lectureCourse)
-			&& this.lectureStartTime.equals(castOther.lectureStartTime)
-			&& this.lectureEndTime.equals(castOther.lectureEndTime)
-			&& this.student.equals(castOther.student);
-	}
-
-	public int hashCode() {
-		final int prime = 31;
-		int hash = 17;
-		hash = hash * prime + this.lectureCourse.hashCode();
-		hash = hash * prime + this.lectureStartTime.hashCode();
-		hash = hash * prime + this.lectureEndTime.hashCode();
-		hash = hash * prime + this.student.hashCode();
-		
-		return hash;
-	}
+  // default serial version id, required for serializable classes.
+  private static final long serialVersionUID = 1L;
+  private Long lectureCourse;
+  private java.util.Date lectureStartTime;
+  private java.util.Date lectureEndTime;
+  private Long student;
+
+  public StudentAttendancePK() {
+  }
+
+  @Column(name = "lecture_course", insertable = false, updatable = false, unique = true, nullable = false)
+  public Long getLectureCourse() {
+    return this.lectureCourse;
+  }
+
+  public void setLectureCourse(Long lectureCourse) {
+    this.lectureCourse = lectureCourse;
+  }
+
+  @Temporal(TemporalType.TIMESTAMP)
+  @Column(name = "lecture_start_time", insertable = false, updatable = false, unique = true, nullable = false)
+  public java.util.Date getLectureStartTime() {
+    return this.lectureStartTime;
+  }
+
+  public void setLectureStartTime(java.util.Date lectureStartTime) {
+    this.lectureStartTime = lectureStartTime;
+  }
+
+  @Temporal(TemporalType.TIMESTAMP)
+  @Column(name = "lecture_end_time", insertable = false, updatable = false, unique = true, nullable = false)
+  public java.util.Date getLectureEndTime() {
+    return this.lectureEndTime;
+  }
+
+  public void setLectureEndTime(java.util.Date lectureEndTime) {
+    this.lectureEndTime = lectureEndTime;
+  }
+
+  @Column(insertable = false, updatable = false, unique = true, nullable = false)
+  public Long getStudent() {
+    return this.student;
+  }
+
+  public void setStudent(Long student) {
+    this.student = student;
+  }
+
+  public boolean equals(Object other) {
+    if (this == other) {
+      return true;
+    }
+    if (!(other instanceof StudentAttendancePK)) {
+      return false;
+    }
+    StudentAttendancePK castOther = (StudentAttendancePK) other;
+    return this.lectureCourse.equals(castOther.lectureCourse)
+        && this.lectureStartTime.equals(castOther.lectureStartTime)
+        && this.lectureEndTime.equals(castOther.lectureEndTime) && this.student.equals(castOther.student);
+  }
+
+  public int hashCode() {
+    final int prime = 31;
+    int hash = 17;
+    hash = hash * prime + this.lectureCourse.hashCode();
+    hash = hash * prime + this.lectureStartTime.hashCode();
+    hash = hash * prime + this.lectureEndTime.hashCode();
+    hash = hash * prime + this.student.hashCode();
+
+    return hash;
+  }
 }
\ No newline at end of file

=== modified file 'src/main/java/db/Teach.java'
--- src/main/java/DB/Teach.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/Teach.java	2017-08-18 12:02:27 +0000
@@ -3,29 +3,27 @@
 import java.io.Serializable;
 import javax.persistence.*;
 
-
 /**
  * The persistent class for the teaches database table.
  * 
  */
 @Entity
-@Table(name="teaches")
-@NamedQuery(name="Teach.findAll", query="SELECT t FROM Teach t")
+@Table(name = "teaches")
+@NamedQuery(name = "Teach.findAll", query = "SELECT t FROM Teach t")
 public class Teach implements Serializable {
-	private static final long serialVersionUID = 1L;
-	private TeachPK id;
-
-	public Teach() {
-	}
-
-
-	@EmbeddedId
-	public TeachPK getId() {
-		return this.id;
-	}
-
-	public void setId(TeachPK id) {
-		this.id = id;
-	}
+  private static final long serialVersionUID = 1L;
+  private TeachPK id;
+
+  public Teach() {
+  }
+
+  @EmbeddedId
+  public TeachPK getId() {
+    return this.id;
+  }
+
+  public void setId(TeachPK id) {
+    this.id = id;
+  }
 
 }
\ No newline at end of file

=== modified file 'src/main/java/db/TeachPK.java'
--- src/main/java/DB/TeachPK.java	2017-08-17 11:10:50 +0000
+++ src/main/java/db/TeachPK.java	2017-08-18 12:02:27 +0000
@@ -9,49 +9,49 @@
  */
 @Embeddable
 public class TeachPK implements Serializable {
-	//default serial version id, required for serializable classes.
-	private static final long serialVersionUID = 1L;
-	private Long course;
-	private Long staff;
-
-	public TeachPK() {
-	}
-
-	@Column(insertable=false, updatable=false, unique=true, nullable=false)
-	public Long getCourse() {
-		return this.course;
-	}
-	public void setCourse(Long course) {
-		this.course = course;
-	}
-
-	@Column(insertable=false, updatable=false, unique=true, nullable=false)
-	public Long getStaff() {
-		return this.staff;
-	}
-	public void setStaff(Long staff) {
-		this.staff = staff;
-	}
-
-	public boolean equals(Object other) {
-		if (this == other) {
-			return true;
-		}
-		if (!(other instanceof TeachPK)) {
-			return false;
-		}
-		TeachPK castOther = (TeachPK)other;
-		return 
-			this.course.equals(castOther.course)
-			&& this.staff.equals(castOther.staff);
-	}
-
-	public int hashCode() {
-		final int prime = 31;
-		int hash = 17;
-		hash = hash * prime + this.course.hashCode();
-		hash = hash * prime + this.staff.hashCode();
-		
-		return hash;
-	}
+  // default serial version id, required for serializable classes.
+  private static final long serialVersionUID = 1L;
+  private Long course;
+  private Long staff;
+
+  public TeachPK() {
+  }
+
+  @Column(insertable = false, updatable = false, unique = true, nullable = false)
+  public Long getCourse() {
+    return this.course;
+  }
+
+  public void setCourse(Long course) {
+    this.course = course;
+  }
+
+  @Column(insertable = false, updatable = false, unique = true, nullable = false)
+  public Long getStaff() {
+    return this.staff;
+  }
+
+  public void setStaff(Long staff) {
+    this.staff = staff;
+  }
+
+  public boolean equals(Object other) {
+    if (this == other) {
+      return true;
+    }
+    if (!(other instanceof TeachPK)) {
+      return false;
+    }
+    TeachPK castOther = (TeachPK) other;
+    return this.course.equals(castOther.course) && this.staff.equals(castOther.staff);
+  }
+
+  public int hashCode() {
+    final int prime = 31;
+    int hash = 17;
+    hash = hash * prime + this.course.hashCode();
+    hash = hash * prime + this.staff.hashCode();
+
+    return hash;
+  }
 }
\ No newline at end of file

=== modified file 'src/main/webapp/WEB-INF/templates/page_header.xhtml'
--- src/main/webapp/WEB-INF/templates/page_header.xhtml	2017-08-11 12:15:56 +0000
+++ src/main/webapp/WEB-INF/templates/page_header.xhtml	2017-08-23 09:48:39 +0000
@@ -1,14 +1,18 @@
-<?xml version="1.0" encoding="UTF-8"?>
 <!DOCTYPE html>
-<html xmlns="http://www.w3.org/1999/xhtml"
-      xmlns:h="http://xmlns.jcp.org/jsf/html"
-      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
-      xmlns:f="http://xmlns.jcp.org/jsf/core"
-      xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
+<html lang="en" xmlns:h="http://xmlns.jcp.org/jsf/html"
+  xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
+  xmlns:f="http://xmlns.jcp.org/jsf/core"
+  xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
 <ui:composition>
-    <div class="header_bar">
-        <h1>${pageTitle}</h1>
-        
-    </div>
+  <div class="header_bar">
+    <header>
+      <a href="#{configBean.headerTitleUrl}">
+        <h1>#{configBean.pageTitle}</h1>
+      </a>
+      <a href="#{configBean.headerSubTitleUrl}">
+        <p>#{configBean.subTitle}</p>
+      </a>
+    </header>
+  </div>
 </ui:composition>
 </html>

=== modified file 'src/main/webapp/WEB-INF/web.xml'
--- src/main/webapp/WEB-INF/web.xml	2017-08-02 14:06:36 +0000
+++ src/main/webapp/WEB-INF/web.xml	2017-08-23 07:33:51 +0000
@@ -1,10 +1,10 @@
 <?xml version="1.0"?>
 
 <web-app xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
-         xmlns="http://java.sun.com/xml/ns/javaee"
-         xsi:schemaLocation="http://java.sun.com/xml/ns/javaee
+  xmlns="http://java.sun.com/xml/ns/javaee"
+  xsi:schemaLocation="http://java.sun.com/xml/ns/javaee
       http://java.sun.com/xml/ns/javaee/web-app_2_5.xsd"
-         version="2.5">
+  version="2.5">
 
   <description>MyProject web.xml</description>
 
@@ -25,5 +25,4 @@
   <welcome-file-list>
     <welcome-file>index.xhtml</welcome-file>
   </welcome-file-list>
-
 </web-app>
\ No newline at end of file

=== modified file 'src/main/webapp/index.xhtml'
--- src/main/webapp/index.xhtml	2017-08-03 13:44:11 +0000
+++ src/main/webapp/index.xhtml	2017-08-24 12:54:32 +0000
@@ -1,10 +1,19 @@
-<?xml version="1.0" encoding="UTF-8"?>
+<?xml version="1.0" encoding="UTF-8" ?>
 <!DOCTYPE html>
 <html xmlns="http://www.w3.org/1999/xhtml"
-      xmlns:h="http://xmlns.jcp.org/jsf/html"
-      xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
-      xmlns:f="http://xmlns.jcp.org/jsf/core">
-<f:view>
-     <h:outputLabel value="Hello, world"/>
-</f:view>
+  xmlns:ui="http://java.sun.com/jsf/facelets"
+  xmlns:f="http://xmlns.jcp.org/jsf/core"
+  xmlns:h="http://xmlns.jcp.org/jsf/html"
+  xmlns:pt="http://xmlns.jcp.org/jsf/passthrough">
+<h:head>
+  <h:outputStylesheet library="css" name="main.css" />
+  <title>${configBean.pageTitle} - ${configBean.subTitle}</title>
+</h:head>
+<h:body>
+  <ui:decorate template="WEB-INF/templates/page_header.xhtml" />
+
+  <div class="main-view">
+    <!--  Stuffs goes here. -->
+  </div>
+</h:body>
 </html>

=== added directory 'src/main/webapp/resources'
=== added directory 'src/main/webapp/resources/css'
=== added file 'src/main/webapp/resources/css/main.css'
--- src/main/webapp/resources/css/main.css	1970-01-01 00:00:00 +0000
+++ src/main/webapp/resources/css/main.css	2017-08-28 13:28:34 +0000
@@ -0,0 +1,53 @@
+body {
+  padding: 0px;
+  margin: 0px;
+}
+
+a:visited {
+  color: darkblue;
+}
+
+a:hover {
+  color: darkblue;
+}
+
+a {
+  color: darkblue;
+}
+
+.header_bar {
+  background-color: lightgray;
+  margin-left: 0px;
+  margin-top: -4.5em;
+  box-shadow: 0px 5px 5px black;
+  margin-right: 0px;
+  z-index: 666 !important;
+  position: fixed;
+  width: 100%;
+}
+
+.header_bar header {
+  margin: 0px;
+  padding: 9px;
+  padding-top: 0px;
+}
+
+.header_bar header h1 {
+  padding: 0px;
+  margin: 0px;
+}
+.header_bar header p {
+  padding: 0px;
+  margin: 0px;
+}
+
+
+.main-view {
+  width: 70em;
+  min-height: 10em;
+  margin-left: auto;
+  margin-right: auto;
+  margin-top:4.50em;
+  background-color: lightgray;
+  box-shadow: 0px 0px 5px black;
+}

=== added directory 'src/test'
=== added directory 'src/test/java'
=== added file 'src/test/java/AllTests.java'
--- src/test/java/AllTests.java	1970-01-01 00:00:00 +0000
+++ src/test/java/AllTests.java	2017-08-23 07:33:51 +0000
@@ -0,0 +1,9 @@
+import org.junit.runner.RunWith;
+import org.junit.runners.Suite;
+import org.junit.runners.Suite.SuiteClasses;
+
+@RunWith(Suite.class)
+@SuiteClasses({ TestHash.class })
+public class AllTests {
+
+}

=== added file 'src/test/java/TestHash.java'
--- src/test/java/TestHash.java	1970-01-01 00:00:00 +0000
+++ src/test/java/TestHash.java	2017-08-23 07:33:51 +0000
@@ -0,0 +1,12 @@
+import org.junit.*;
+
+import common.Utils;
+
+
+public class TestHash {
+  @Test
+  public void test1 () {
+    System.out.println(Utils.hash_func("Hello World"));
+  }
+
+}

